'use strict';

const col = require('chalk');

function regx(keyword) {
  return new RegExp('\\b' + keyword + '\\b');
}

function hl(str, words, hcol, cb) {
  try {
    if (typeof words === 'string' && regx(words).test(str)) {
      return cb(null, str.replace(new RegExp(regx(words), 'g'), col[hcol](words)));
    } else if (Array.isArray(words) && words.length > 0) {
      words.forEach((word) => {
        if (typeof hcol === 'string' && regx(word).test(str)) {  
          str = str.replace(new RegExp(regx(word), 'g'), col[hcol](word));
        } else if (Array.isArray(hcol) && hcol.length > 0) {
          hcol.forEach((c) => {
            if (hcol.indexOf(c) === words.indexOf(word) && regx(word).test(str)) {  
              str = str.replace(new RegExp(regx(word), 'g'), col[c](word));
            }
          });
        }
      });
      return cb(null, str);
    } else {
      return cb(null, str);
    }
  } catch(err) {
    return cb(err, null);
  }
}

module.exports = hl;
